# Docker container für einen Minecraft Server auf PaperMC-Basis
Dieses Image basiert auf der Arbeit von https://github.com/Phyremaster/papermc-docker und wurde so modifiziert sodass nurnoch dieser Befehl genutzt werden muss um das Image auf einen beliebigen Server zu starten:<br />

# Setup

```sudo docker run -d -it -p 25565:25565 -v unimc:/papermc:Z -v unibackup:/Backup:Z --restart on-failure gitlab.cl.uni-heidelberg.de:5050/tmueller/clspigot-docker:latest```

- Port
  - Muss immer angegeben werden um den Server ausserhalb des containers zugänglich zu machen.
  - `-p <12345>:25565`
  - Sofern dynmap über den internen webserver des plugins ausgeliefert werden soll muss noch der port 8123 gemapped werden 
- Volume
  - Zum festlegen eines Namen des Volumes
  - Sofern Konfigurationsdaten bearbeitet werden sollen kann es sinn machen eine Verlinkung zu einem Ordner festzulegen, da sonst dies nur möglich ist wenn die Flag `-i` gesetzt ist und man per console im container arbeiten müsste. (Siehe Abschnitt Terminal)
  - `-v <my_volume_name>:/papermc`
  - `-v </path/to/files>:/papermc:Z`
  - `-v </path/to/backup>:/Backup:Z`
- Detached
  - Dockerspezifischer Parameter um container im Hintergrund laufen zu lassen
  - `-d`
- Terminal
  - Option für TTY und Interactive mode, mehr dazu kann in der docker doc nachgelesen werden
  - `-t` and `-i` in any order
  - `-ti` or `-it`
- Restart Policy
  - Erklärt sich von selbst, dient zum automatischem neustarten wnn mal irgednwas schief läuft.
  - Bitte nur über die minecraftconsole den server stoppen um Fehler insbesondere an der minecraftworld zu vermeiden.
  - `--restart on-failure`
- Name
  - Dient zum festlegen eines Namens für den Container.
  - `--name "<my-container-name>"`
Der letzte Parameter ist etwas umfangreicher und wird unter Environment Variablen erklärt
### Environment Variablen
Um eine Env Variable festzulegen gilt das folgenden Muster: `-e <NAME>="<VALUE>"` where `<NAME>` 
Der Platzhalter `<Name>`Wird durch den Namen der Env Variable ersetzt und `<value>` wird mit dem zuzuweisenden Wert ersetzt.
- Minecraft Version
  - **Name:** `MC_VERSION`
  - Legt die zu verwendene MC-Version fest.
  - !Wichtig! Die spezifizierte Version muss auch einen PaperMC Release haben, da sonst der Build fehlschlägt
  - [Aktuelle PaperMC-Builds](https://papermc.io/downloads) (Zuletzt 1.16.4) 
  - `-e MC_VERSION="<latest>"`
  - Die Buildnummern (ie. #355) sind normalerweise irrelevant hier kann man es bei latest belassen, falls jedoch ein spezifischer Build verwendet werden soll, lässt sich das durch den Parameter erreichen:
  - `-e PAPER_BUILD="<latest>"`
- RAM
  - **Name:** `MC_RAM`
  - Legt die Speichermenge für java fest. Zahl muss M für Megabytes oder G für Gigabytes enthalten.
  - Für die Flags der Java VM die ich aktuell nutze empfielt es sich 6GB minimum zuzuweisen oder maximal 10GB
  - `-e MC_RAM="<4G>"`
- Java options
  - **Name:** `JAVA_OPTS`
  - Javaspezifische Parameter, nur ändern wenn es notwendig ist und man weis was man tut!
  - Ausnahme, wenn der Server mit weniger RAM laufen soll eignet es sich hier die für spigot üblichen flags (siehe SpigotMC Docs) einzusetzen um aikars flags zu überschreiben
  - Mit genug Erfahrung können auch die Werte von den flags angepasst werden, aber auch hier gilt: Vorsicht nur anpassen wenn man weis was man da tut
  - `-e JAVA_OPTS="-XX:+UseG1GC -XX:+ParallelRefProcEnabled -XX:MaxGCPauseMillis=200 -XX:+UnlockExperimentalVMOptions -XX:+DisableExplicitGC -XX:+AlwaysPreTouch -XX:G1NewSizePercent=30 -XX:G1MaxNewSizePercent=40 -XX:G1HeapRegionSize=8M -XX:G1ReservePercent=20 -XX:G1HeapWastePercent=5 -XX:G1MixedGCCountTarget=4 -XX:InitiatingHeapOccupancyPercent=15 -XX:G1MixedGCLiveThresholdPercent=90 -XX:G1RSetUpdatingPauseTimePercent=5 -XX:SurvivorRatio=32 -XX:+PerfDisableSharedMem -XX:MaxTenuringThreshold=1 -Dusing.aikars.flags=https://mcflags.emc.gs -Daikars.new.flags=true"`

# Befehle
Innerhalb von Minecraft kann per `/backup` der Server gesichert werden.
Zum stoppen des Servers einfach über docker den container stoppen.

Zur Konsole vom Minecraftserver kommt man indem man diesen befehl eingibt: `docker exec -it <container name> /bin/bash`
und danach screen -r mc

# Technical
This project *does **NOT** redistribute the Minecraft server files*. Instead, the (very small) script that is inside of the image, `papermc.sh`, downloads these files from their official sources during installation.

**PLEASE NOTE:** This is an unofficial project. I did not create PaperMC. [This is the official PaperMC website.](https://papermc.io/)

## Project Pages des Unsprünglichem Image von Phyremaster:
- [GitHub page](https://github.com/Phyremaster/papermc-docker).
- [Docker Hub page](https://hub.docker.com/r/phyremaster/papermc).



